const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Financial_accountsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_accounts = await db.financial_accounts.create(
      {
        id: data.id || undefined,

        account_name: data.account_name || null,
        account_type: data.account_type || null,
        balance: data.balance || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await financial_accounts.setCompanies(data.companies || null, {
      transaction,
    });

    return financial_accounts;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const financial_accountsData = data.map((item, index) => ({
      id: item.id || undefined,

      account_name: item.account_name || null,
      account_type: item.account_type || null,
      balance: item.balance || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const financial_accounts = await db.financial_accounts.bulkCreate(
      financial_accountsData,
      { transaction },
    );

    // For each item created, replace relation files

    return financial_accounts;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const financial_accounts = await db.financial_accounts.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.account_name !== undefined)
      updatePayload.account_name = data.account_name;

    if (data.account_type !== undefined)
      updatePayload.account_type = data.account_type;

    if (data.balance !== undefined) updatePayload.balance = data.balance;

    updatePayload.updatedById = currentUser.id;

    await financial_accounts.update(updatePayload, { transaction });

    if (data.companies !== undefined) {
      await financial_accounts.setCompanies(
        data.companies,

        { transaction },
      );
    }

    return financial_accounts;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_accounts = await db.financial_accounts.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of financial_accounts) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of financial_accounts) {
        await record.destroy({ transaction });
      }
    });

    return financial_accounts;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const financial_accounts = await db.financial_accounts.findByPk(
      id,
      options,
    );

    await financial_accounts.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await financial_accounts.destroy({
      transaction,
    });

    return financial_accounts;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const financial_accounts = await db.financial_accounts.findOne(
      { where },
      { transaction },
    );

    if (!financial_accounts) {
      return financial_accounts;
    }

    const output = financial_accounts.get({ plain: true });

    output.transactions_account =
      await financial_accounts.getTransactions_account({
        transaction,
      });

    output.companies = await financial_accounts.getCompanies({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userCompanies = (user && user.companies?.id) || null;

    if (userCompanies) {
      if (options?.currentUser?.companiesId) {
        where.companiesId = options.currentUser.companiesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.companies,
        as: 'companies',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.account_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'financial_accounts',
            'account_name',
            filter.account_name,
          ),
        };
      }

      if (filter.balanceRange) {
        const [start, end] = filter.balanceRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            balance: {
              ...where.balance,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            balance: {
              ...where.balance,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.account_type) {
        where = {
          ...where,
          account_type: filter.account_type,
        };
      }

      if (filter.companies) {
        const listItems = filter.companies.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          companiesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.companiesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.financial_accounts.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('financial_accounts', 'account_name', query),
        ],
      };
    }

    const records = await db.financial_accounts.findAll({
      attributes: ['id', 'account_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['account_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.account_name,
    }));
  }
};
